---------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                        --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.               --
--  License and contact information are in the file oci.ads  --
---------------------------------------------------------------
package body oci.EnvCreate80 is

   flag : boolean := False;

   function OCIEnvCreate
     (Envh : access OCIEnv;
      Mode : Ub4;
      Ctxp : Undefined := Empty;
      Malocfp : Undefined := Empty;
      Ralocfp : Undefined := Empty;
      Mfreefp : Undefined := Empty;
      Xtramemsz : Undefined := Empty;
      Usrmempp : Undefined := Empty)
      return Sword
   is
      use type Ub4;
      use type sword;
      init_mode : ub4 := 0;
      rc : sword;
   begin
      if not Flag then
         rc := OCIInitialize (mode =>
            Mode and (OCI_THREADED + OCI_OBJECT + OCI_EVENTS + OCI_SHARED),
            Ctxp => Ctxp,
            Malocfp => Malocfp,
            Ralocfp => Ralocfp,
            Mfreefp => Mfreefp);
         if rc = OCI_SUCCESS then
            Flag := True;
         else
            return rc;
         end if;
      end if;
      if (Mode and OCI_NO_UCB) /= 0 then
         init_mode := OCI_ENV_NO_UCB;
      end if;
      if (Mode and OCI_NO_MUTEX) /= 0 then
         init_mode := init_mode or OCI_ENV_NO_MUTEX;
      end if;
      return OCIEnvInit (Envh, init_mode, Xtramemsz, Usrmempp);
   end OCIEnvCreate;

   function OCILOBCREATETEMPORARY (svchp   : OCISVCCTX;
                                   errhp   : OCIERROR;
                                   locp    : OCILOBLOCATOR;
                                   csid    : ub2;
                                   csfrm   : ub1;
                                   lobtype : ub1;
                                   cache   : c.int;
                                   duration : OCIDURATION)
                                             return sword is
   begin
      raise Not_Implemented_in_this_version;
      return OCI_ERROR;
   end OCILOBCREATETEMPORARY;

   function Not_Implemented_2 return sword is
   begin
      raise Not_Implemented_in_this_version;
      return OCI_ERROR;
   end Not_Implemented_2;

end oci.EnvCreate80;

