------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information could be found in oci.ads  --
------------------------------------------------------------------------------
with OCI.Environments;
with OCI.Thick.Servers;
package OCI.Thick.Connections is

   use OCI.Thick.Servers;

   type Connection is new Handle_Reference with private;

--   type Connection is tagged private;

   function Logon(Server_Name : String; User : String; Password : String)
      return Connection;
   function Logon(Connect : String) return Connection;
   
   function Logon (DB : Server;
      User : String; Password : String) return Connection;
   
   procedure Logoff(Connect : in out Connection);
   
   function Server_Version(Connect : in Connection) 
      return String;
      
   procedure Commit(Connect : in Connection);
   procedure Rollback(Connect : in Connection);
   
   procedure Break (It : Connection);
   procedure Reset (It : Connection);


   -- get Connection for extproc callbacks
   function Get_Connection(Context: OCIExtProcContext) 
      return Connection;
   
private

   type Connection is new Handle_Reference with record
--      Error : OCI.Task_Error.Thread_Error;
      DB : Server;
      Sessn : OCISession := OCISession (Empty_Handle);
      Environment : OCI.Environments.Thread_Environment;
   end record;

   procedure Destroy(Object : in out Connection);

end OCI.Thick.Connections;