------------------------------------------------------------------------------
--  Ada95 Interface to Oracle RDBMS                                         --
--  Copyright (C) 2000-2001 Dmitriy Anisimkov.                              --
--  License text and authors contact information could be found in oci.ads  --
------------------------------------------------------------------------------
with OCI.Thick.Variable;
with OCI.Thick.Statements;

generic
   type Variable_Type is private;
   Type_Id : in ub2;
   
package OCI.Thick.Var is

   use Statements;
   
   package V is new OCI.Thick.Variable (Variable_Type);
   use V;
   
   type Variable is new Var_Type (Type_Id) with null record;

   procedure Bind(Stmt : Statement; Value : in out Var_Type'Class; Name : String) 
     renames V.Bind;
   procedure Bind(Stmt : Statement; Value : in out Var_Type'Class; Position : Positive)
     renames V.Bind;
   procedure Define(Stmt : Statement; Value : in out Var_Type'Class; Position : Positive)
     renames V.Define;
   procedure Set_Value(Var : in out Var_Type'Class; Value : Variable_Type)
     renames V.Set_Value;
   function Get_Value(Var : Var_Type'Class) return Variable_Type
     renames V.Get_Value;
   function Value(Var : Var_Type'Class) return Variable_Type renames Get_Value;
   function Get_Value_Internal(Var : Var_Type'Class) return Variable_Type
     renames V.Get_Value_Internal;

      
end OCI.Thick.Var;