with Ada.Unchecked_Deallocation;
--with Ada.Text_IO; use Ada.Text_IO;
with Ada.Tags;
package body Reference_Finalization is

   procedure Free is new Ada.Unchecked_Deallocation (Counter, Access_Count);
   
   protected body Counter is
   
      procedure Dec (Zero : out Boolean) is
      begin
         Zero := Data = 0;
         Data := Data - 1;
      end;
      
      procedure Inc is
      begin
        Data := Data + 1;
      end;
      
   end Counter;

   function Class_Name (Object : in Controlled_Reference) return String;
   
   pragma Inline (Class_Name);
   
   
   function Class_Name (Object : in Controlled_Reference) return String
   is
   begin
       return Ada.Tags.External_Tag (Controlled_Reference'Class(Object)'Tag);
   end;

--   protected body Counters is
--      
--      procedure Add (Key : in String; Value : Integer) is
--      
--         procedure Modify (Key: in String; Value : in out Integer) is
--         begin
--            Modify.Value := Modify.Value + Add.Value;
--         end;

--         procedure Update is new Class_Counter.Update_Value_Or_Status_G (Modify);

--         Found : Boolean;
--      begin
--         Update (Table, Key, Found);
--         if not Found then
--            Class_Counter.Insert (Table, Key, 1);
--         end if;
--      end;
--      
--      procedure Append (
--         Result : in out Unbounded_String;
--         Field_Delimiter : String;
--         Line_Delimiter : String);
--      
--         procedure Action (Key: in String;
--            Value: in Integer;
--            Order_Number: in Positive;
--            Continue: in out Boolean) is
--         begin
--            Append (Result, Key & Field_Delimiter
--               & Integer'Image (Value) & Line_Delimiter);
--         end;
--         
--         procedure For_Each is new Class_Counter.Traverse_Desc_G (Action); 
--         
--      begin
--         For_Each (Table);
--      end Append;
--   
--   end Counters;


--   procedure Append (
--      Result : in out Unbounded_String;
--      Field_Delimiter : String := " ";
--      Line_Delimiter : String := "" & ASCII.LF)
--   is
--   begin
--     null;
--   end;
      

   procedure Initialize (Object : in out Controlled_Reference) is
   begin
      Object.Refer := new Counter;
--      Put_Line ("Init " & Class_Name (Object));
--      pragma Debug (Counters.Add (Class_Name (Object), 1));
   end;
   
   ------------
   -- Adjust --
   ------------

   procedure Adjust (Object : in out Controlled_Reference) is
   begin
--      Put_Line ("Adjust " & Class_Name (Object));
      Object.Refer.Inc;
   end Adjust;

   --------------
   -- Finalize --
   --------------

   procedure Finalize (Object : in out Controlled_Reference) is
      Internal_Error : exception;
      Zero : Boolean;
--         pragma Debug (Counters.Add (Class_Name (Object), -1));
   begin
      Object.Refer.Dec (Zero);
      if Zero then
--         Put_Line ("Destroy " & Class_Name (Object));
         Destroy (Controlled_Reference'Class (Object));
--         Put_Line ("Free " & Class_Name (Object));
         Free (Object.Refer);
--         Put_Line ("Done " & Class_Name (Object));
--      else
--         Put ("Final ");  Put_Line (Class_Name (Object));
      end if;
   end Finalize;

end Reference_Finalization;

