with System, Ada.Finalization;
--with Table_Of_Strings_And_Static_Values_G;
--with Ada.Strings.Unbounded;

package Reference_Finalization is

   package AF renames Ada.Finalization;
  
   type Controlled_Reference is abstract new AF.Controlled with private;
   
   procedure Destroy (Object : in out Controlled_Reference) is abstract;
   
--   package Class_Counter is new Table_Of_Strings_And_Static_Values_G (
--      Character_Type => Character,
--      String_Type => String,
--      Less => "<",
--      Equals => "=",
--      Value_Type => Integer);
      
   
--   use Ada.Strings.Unbounded;
--   
--   procedure Append (
--      Result : in out Unbounded_String;
--      Field_Delimiter : String := " ";
--      Line_Delimiter : String := "" & ASCII.LF);

private

--   type Output_Procedure is access procedure (Key : String; Count : Natural);

--   protected Counters is
--      procedure Append (
--         Result : in out Unbounded_String;
--         Field_Delimiter : String;
--         Line_Delimiter : String);
--   private
--      Table : Class_Counter.Table_Type;
--      procedure Add (Key : in String; Value : Integer);
--   end Counters;
   
   type Ref_Count is mod System.Max_Binary_Modulus;
   
   protected type Counter is
      procedure Dec (Zero : out Boolean);
      procedure Inc;
   private
      Data : Ref_Count := 0;
   end Counter;
  
   type Access_Count is access all Counter;
   
   type Controlled_Reference is abstract new AF.Controlled with record
      Refer : Access_Count := null;
   end record;
   
   procedure Initialize (Object : in out Controlled_Reference);
   procedure Adjust    (Object : in out Controlled_Reference);
   procedure Finalize  (Object : in out Controlled_Reference);

end Reference_Finalization;